JUCE: dsp::LookupTableTransform< FloatType > Class Template Reference

JUCE

Public Member Functions | Static Public Member Functions | List of all members
dsp::LookupTableTransform< FloatType > Class Template Reference
juce_dsp » maths

Class for approximating expensive arithmetic operations. More...

`#include <juce_LookupTable.h>`

## Public Member Functions
| LookupTableTransform ()=default
| Creates an uninitialised LookupTableTransform object. More...
| LookupTableTransform (const std::function< FloatType(FloatType)> &functionToApproximate, FloatType minInputValueToUse, FloatType maxInputValueToUse, size_t numPoints)
| Creates and initialises a LookupTableTransform object. More...
void | initialise (const std::function< FloatType(FloatType)> &functionToApproximate, FloatType minInputValueToUse, FloatType maxInputValueToUse, size_t numPoints)
| Initialises or changes the parameters of a LookupTableTransform object. More...
FloatType | processSampleUnchecked (FloatType value) const noexcept
| Calculates the approximated value for the given input value without range checking. More...
FloatType | processSample (FloatType value) const noexcept
| Calculates the approximated value for the given input value with range checking. More...
FloatType | operator[] (FloatType index) const noexcept
FloatType | operator() (FloatType index) const noexcept
void | processUnchecked (const FloatType *input, FloatType *output, size_t numSamples) const noexcept
| Processes an array of input values without range checking. More...
void | process (const FloatType *input, FloatType *output, size_t numSamples) const noexcept
| Processes an array of input values with range checking. More...

## Static Public Member Functions
static double | calculateMaxRelativeError (const std::function< FloatType(FloatType)> &functionToApproximate, FloatType minInputValue, FloatType maxInputValue, size_t numPoints, size_t numTestPoints=0)
| Calculates the maximum relative error of the approximation for the specified parameter set. More...

## Detailed Description

template<typename FloatType>
class dsp::LookupTableTransform< FloatType >

Class for approximating expensive arithmetic operations.

Once initialised, this class can be used just like the function it approximates via operator().

Example:

    LookupTableTransform<float> tanhApprox ([] (float x) { return std::tanh (x); }, -5.0f, 5.0f, 64);
    auto outValue = tanhApprox (4.2f);

Note: If you try to call the function with an input outside the provided range, it will return either the first or the last recorded LookupTable value.

See also
  LookupTable

## Constructor & Destructor Documentation

## ◆ LookupTableTransform() [1/2]

template<typename FloatType >

dsp::LookupTableTransform< FloatType >::LookupTableTransform | ( |  | ) |
| default

Creates an uninitialised LookupTableTransform object.

You need to call initialise() before using the object. Prefer using the non-default constructor instead.

See also
  initialise

## ◆ LookupTableTransform() [2/2]

template<typename FloatType >

dsp::LookupTableTransform< FloatType >::LookupTableTransform | ( | const std::function< FloatType(FloatType)> & | functionToApproximate,
|  | FloatType | minInputValueToUse,
|  | FloatType | maxInputValueToUse,
|  | size_t | numPoints
| ) |  |

Creates and initialises a LookupTableTransform object.

Parameters

  functionToApproximate | The function to be approximated. This should be a mapping from a FloatType to FloatType.
  minInputValueToUse | The lowest input value used. The approximation will fail for values lower than this.
  maxInputValueToUse | The highest input value used. The approximation will fail for values higher than this.
  numPoints | The number of pre-calculated values stored.

## Member Function Documentation

## ◆ initialise()

template<typename FloatType >

void dsp::LookupTableTransform< FloatType >::initialise | ( | const std::function< FloatType(FloatType)> & | functionToApproximate,
|  | FloatType | minInputValueToUse,
|  | FloatType | maxInputValueToUse,
|  | size_t | numPoints
| ) |  |

Initialises or changes the parameters of a LookupTableTransform object.

Parameters

  functionToApproximate | The function to be approximated. This should be a mapping from a FloatType to FloatType.
  minInputValueToUse | The lowest input value used. The approximation will fail for values lower than this.
  maxInputValueToUse | The highest input value used. The approximation will fail for values higher than this.
  numPoints | The number of pre-calculated values stored.

## ◆ processSampleUnchecked()

template<typename FloatType >

FloatType dsp::LookupTableTransform< FloatType >::processSampleUnchecked | ( | FloatType | value | ) | const
| noexcept

Calculates the approximated value for the given input value without range checking.

Use this if you can guarantee that the input value is within the range specified in the constructor or initialise(), otherwise use processSample().

Parameters

  value | The approximation is calculated for this input value.

Returns
  The approximated value for the provided input value.

See also
  processSample, operator(), operator[]

References jassert, and gl::value.

Referenced by dsp::LookupTableTransform< FloatType >::operator[](), and dsp::LookupTableTransform< FloatType >::processUnchecked().

## ◆ processSample()

template<typename FloatType >

FloatType dsp::LookupTableTransform< FloatType >::processSample | ( | FloatType | value | ) | const
| noexcept

Calculates the approximated value for the given input value with range checking.

This can be called with any input values. Out-of-range input values will be clipped to the specified input range.

If the index is guaranteed to be in range use the faster processSampleUnchecked() instead.

Parameters

  value | The approximation is calculated for this input value.

Returns
  The approximated value for the provided input value.

See also
  processSampleUnchecked, operator(), operator[]

References gl::index, isPositiveAndBelow(), jassert, jlimit(), and gl::value.

Referenced by dsp::LookupTableTransform< FloatType >::operator()(), and dsp::LookupTableTransform< FloatType >::process().

## ◆ operator[]()

template<typename FloatType >

FloatType dsp::LookupTableTransform< FloatType >::operator[] | ( | FloatType | index | ) | const
| noexcept

See also
  processSampleUnchecked

References gl::index, and dsp::LookupTableTransform< FloatType >::processSampleUnchecked().

## ◆ operator()()

template<typename FloatType >

FloatType dsp::LookupTableTransform< FloatType >::operator() | ( | FloatType | index | ) | const
| noexcept

See also
  processSample

References gl::index, and dsp::LookupTableTransform< FloatType >::processSample().

## ◆ processUnchecked()

template<typename FloatType >

void dsp::LookupTableTransform< FloatType >::processUnchecked | ( | const FloatType * | input,
|  | FloatType * | output,
|  | size_t | numSamples
| ) |  | const
| noexcept

Processes an array of input values without range checking.

See also
  process

References gl::input, gl::output, and dsp::LookupTableTransform< FloatType >::processSampleUnchecked().

## ◆ process()

template<typename FloatType >

void dsp::LookupTableTransform< FloatType >::process | ( | const FloatType * | input,
|  | FloatType * | output,
|  | size_t | numSamples
| ) |  | const
| noexcept

Processes an array of input values with range checking.

See also
  processUnchecked

References gl::input, gl::output, and dsp::LookupTableTransform< FloatType >::processSample().

## ◆ calculateMaxRelativeError()

template<typename FloatType >

static double dsp::LookupTableTransform< FloatType >::calculateMaxRelativeError | ( | const std::function< FloatType(FloatType)> & | functionToApproximate,
|  | FloatType | minInputValue,
|  | FloatType | maxInputValue,
|  | size_t | numPoints,
|  | size_t | numTestPoints = `0`
| ) |  |
| static

Calculates the maximum relative error of the approximation for the specified parameter set.

The closer the returned value is to zero the more accurate the approximation is.

This function compares the approximated output of this class to the function it approximates at a range of points and returns the maximum relative error. This can be used to determine if the approximation is suitable for the given problem. The accuracy of the approximation can generally be improved by increasing numPoints.

Parameters

  functionToApproximate | The approximated function. This should be a mapping from a FloatType to FloatType.
  minInputValue | The lowest input value used.
  maxInputValue | The highest input value used.
  numPoints | The number of pre-calculated values stored.
  numTestPoints | The number of input values used for error calculation. Higher numbers can increase the accuracy of the error calculation. If it's zero then 100 * numPoints will be used.

The documentation for this class was generated from the following file:

- juce_LookupTable.h